<template>
  <div class="link-info-container" v-if="valueLocal !== null && valueLocal.role">
    <div class="go-back" @click="goback">
    </div>
    <h3> {{ getRoleDescription.role }}</h3>
    <div class="row">
      <div class="col-xs-12">
        <ob-input
                :pre-icon="'profile-eye blue'"
                :disabled="true"
                :value="dictionaryRu.linkFormControl.visibilityPlaceholder"
                :label="dictionaryRu.linkFormControl.visibility"
        ></ob-input>
      </div>
    </div>
    <div class="row">
      <div class="col-xs-6">
        <ob-input
                :value="getPublicLinkLeft"
                :label="getRoleDescription.publicLinkName"
                :disabled="true"
                :pre-icon="isLink ? 'link-left blue' : ''"
        ></ob-input>
      </div>
      <div class="col-xs-6">
        <ob-input
                :value="getPublicLinkRight"
                :label="dictionaryRu.linkFormControl.publicLinkRight"
                :disabled="true"
                :pre-icon="isLink ? 'link-right blue' : ''"
        ></ob-input>
      </div>
    </div>
    <div class="row">
      <div class="col-xs-6">
        <ob-input
                :value="getLink"
                :label="dictionaryRu.linkFormControl.link"
                :disabled="true"
                :pre-icon="isLink ? 'link blue' : ''"
        ></ob-input>
      </div>
      <div class="col-xs-6">
        <ob-input
                :value="getDocs"
                :label="dictionaryRu.linkFormControl.contracts"
                :disabled="true"
                :pre-icon="valueLocal.docs > 0 ? 'document blue' : ''"
                :class="{visibility: true, hasIcon: valueLocal.docs}"
        ></ob-input>
      </div>
    </div>

    <div class="line-container control-buttons">
      <i v-if="valueLocal.public_pending || sendRequestStatus"
         class="icon checked green"
         style="font-size: 24px"
      ></i>
      <span
        v-if="valueLocal.public_pending || sendRequestStatus"
        class="green"
      >{{ dictionaryRu.formButton.pending }}</span>

      <div class="controls">
        <div class="block-left" v-if="rejectRequestStatus">
          <i class="icon delete red" style="font-size: 24px"></i>
          <span class="gray">{{ rejectRequestTitle }}</span>
        </div>
        <a
          v-if="isPublicLinkRight()"
          @click="removePublicLink"
        >{{ dictionaryRu.formButton.removePublicLink }}</a>
        <ob-button
                v-if="canCreatePublicLinkRight"
                :label="dictionaryRu.formButton.createPublicLink"
                @click='createPublicLink'
        ></ob-button>
        <ob-button
                v-if="canCreateLink"
                :label="dictionaryRu.formButton.createLink"
                @click='createLink'
        ></ob-button>
      </div>
    </div>
    <div
      v-if="valueLocal.uuid === userData.contractor_uuid"
      class="restriction"
    >
      <span>{{ dictionaryRu.linkStatus.currentUser }}</span>
    </div>
    <template v-else>
      <div
        v-if="valueLocal.restriction"
        class="restriction"
      >
        <i class="icon lock red" style="font-size: 24px"></i>
        <span>{{ dictionaryRu.formButton.lock }}</span>
        <i class="icon question blue" style="font-size: 24px"></i>
      </div>
      <p v-if="valueLocal.pending"></p>
      <div
        v-if="valueLocal.pending"
        class="restriction"
      >
        <i class="icon lock red" style="font-size: 24px"></i>
        <span>{{ dictionaryRu.formButton.process }}</span>
      </div>
    </template>
  </div>
</template>

<script>
import ObInput from "common-components/src/obComponents/obInput";
import ObButton from "common-components/src/obComponents/obButton";
import { dictionary } from '@/translations/ru/LinkBrowserPage';

export default {
  name: 'LinkInfo',
  components: {
    ObButton,
    ObInput,
  },
  props: {
    api: {
      type: Object,
      default: () => {}
    },
    userData: {
      type: Object,
      default: () => {}
    },
    value: {
      type: Object,
      required: false,
      default: () => {}
    }
  },
  data: function () {
    return {
      dictionaryRu: dictionary,
      valueLocal: {},
      domainLocal: {}
    }
  },
  computed: {
    getRoleDescription () {
      let role = this.dictionaryRu.linkTitle.link + ""
      let publicLinkName = ''
      switch (this.valueLocal.role) {
        case 'user':
          role += this.dictionaryRu.linkTitle.user
          publicLinkName = this.dictionaryRu.labelPublicLinkName.user
          break
        case 'supplier':
          role += this.dictionaryRu.linkTitle.supplier
          publicLinkName = this.dictionaryRu.labelPublicLinkName.supplier
          break
        case 'domain-owner':
          role += this.dictionaryRu.linkTitle['domain-owner']
          publicLinkName = this.dictionaryRu.labelPublicLinkName['domain-owner']
          break
        case 'carrier':
          role += this.dictionaryRu.linkTitle.carrier
          publicLinkName = this.dictionaryRu.labelPublicLinkName.carrier
          break
      }
      return {
        role: role + " " + this.valueLocal.title,
        publicLinkName: publicLinkName
      }
    },
    getPublicLinkLeft () {
      return this.isPublicLinkLeft() ? this.dictionaryRu.linkActiveStatus.active : this.dictionaryRu.linkActiveStatus.notActive
    },
    getPublicLinkRight () {
      return this.isPublicLinkRight() ? this.dictionaryRu.linkActiveStatus.active : this.dictionaryRu.linkActiveStatus.notActive
    },
    getLink () {
      return this.isLink ? this.dictionaryRu.linkActiveStatus.active : this.dictionaryRu.linkActiveStatus.notActive
    },
    getDocs () {
      return this.valueLocal.docs > 0 ? this.valueLocal.docs : this.dictionaryRu.linkActiveStatus.notActive
    },
    canCreateLink () {
      return !this.valueLocal.restriction && !this.isLink && !(this.valueLocal.public_pending || this.valueLocal.pending)
    },
    canCreatePublicLinkRight () {
      return this.valueLocal.link_uuid && !this.valueLocal.public_restriction && !this.valueLocal.restriction && !this.isPublicLinkRight() && this.valueLocal.request_status !== 'send' && !(this.valueLocal.public_pending || this.valueLocal.pending)
    },
    sendRequestStatus () {
      return this.valueLocal.request_status === 'send'
    },
    rejectRequestStatus () {
      return this.valueLocal.request_status === 'rejected'
    },
    rejectRequestTitle () {
      return this.dictionaryRu.rejectRequestTitle.pre + ' ' + this.valueLocal.request_date + ' ' + this.dictionaryRu.rejectRequestTitle.post
    },
    isLink () {
      return this.valueLocal.link_type != null
    }
  },
  methods: {
    removePublicLink() {
      let notificationId = new Date().getTime()+'remove';
      this.$notification({type: 'system_notification_in_load', message: 'Удаление', id: notificationId});
      this.api.removePublicLink(
        this.valueLocal.link_uuid,
        {
            is_public: false,
            participant_uuid: this.userData.contractor_uuid
        }
      ).then(()=>{
        this.$notification({
          type: 'system_notification_success',
          message: 'Удалено'
        })
        this.$emit('update-domains')
        if (this.valueLocal.link_type === 'link-right') this.valueLocal.link_type = 'link';
        if (this.valueLocal.link_type === 'link-mutal') this.valueLocal.link_type = 'link-left';
      }).catch((e) => {
        console.error(e);
        this.$notification({
          type: 'system_notification_error',
          message: 'Не удалено'
        })
      }).finally(()=>{
        this.$notification({event: 'close', id: notificationId})
      })
    },
    createPublicLink() {
      if (this.valueLocal.link_uuid) {
        let notificationId = new Date().getTime() + 'save';
        this.$notification({type: 'system_notification_in_load', message: 'Сохранение', id: notificationId});
        this.api.publicateLink({
          from_participant_uuid: this.userData.contractor_uuid,
          to_participant_uuid: this.valueLocal.uuid,
          link_uuid: this.valueLocal.link_uuid
        }).then(() => {
          this.$emit('update-domains')
          this.valueLocal.public_pending = true;
          this.$notification({
            type: 'system_notification_success',
            message: 'Сохранено'
          })
        }).catch((e) => {
          console.error(e);
          this.$notification({
            type: 'system_notification_error',
            message: 'Не сохранено'
          })
        }).finally(() => {
          this.$notification({event: 'close', id: notificationId})
        });
      }
    },
    createLink() {
      let notificationId = new Date().getTime() + 'save';
      this.$notification({type: 'system_notification_in_load', message: 'Сохранение', id: notificationId});
      this.api.createPublicLink({
        from_participant_uuid: this.userData.contractor_uuid,
        to_participant_uuid: this.valueLocal.uuid,
        need_public: false
      }).then(() => {
        this.$emit('update-domains')
        this.valueLocal.pending = true;
        this.$notification({
          type: 'system_notification_success',
          message: 'Сохранено'
        })
      }).catch((e) => {
        console.error(e);
        this.$notification({
          type: 'system_notification_error',
          message: 'Не сохранено'
        })
      }).finally(() => {
        this.$notification({event: 'close', id: notificationId})
      });
    },
    set (data, domain) {
      this.valueLocal = data
      this.domainLocal = domain
    },
    goback () {
      this.$emit('goback')
    },

    isPublicLinkRight () {
      return this.valueLocal.link_type === 'link-right' || this.valueLocal.link_type === 'link-mutal'
    },
    isPublicLinkLeft () {
      return this.valueLocal.link_type === 'link-left' || this.valueLocal.link_type === 'link-mutal'
    }
  }
}
</script>
<style lang="scss">
  .link-info-container {
    padding: 15px;
  }
  .link-info-container .row {
    margin-top: 15px;
    margin-bottom: 15px;
  }
</style>
